## 1.18.4 - 2024-12-23

- Fix non unique identifier
- Post picture image example

## 1.18.3 - 2024-09-05

- Demo blog posts updated
- Identifier added in page data
- Plugins sorted by name

## 1.18.2 - 2024-05-13

- Prevent errors when template file is empty
- Do not stop the build when a page is in error
- Display pages in error when building

## 1.18.1 - 2024-03-26

- Theme improvement
- Block separator line break optional

## 1.18.0 - 2024-03-14

- Theme and content separation
- Retrieve the URL with token of an asset more easily
- Menu plugin Theme
- Breeze and dusk themes added

## 1.17.14 - 2024-01-09

- Serve on IPv6
- Disable default reserved routes in secure mode
- JSON query sort order improvements

## 1.17.13 - 2024-01-03

- Fix disabled pages loaded in JSON query when building
- Codemirror updated to 5.65.16

## 1.17.12 - 2023-10-22

- Behavior on unsolicited environments during build
- Allow specifying environments in the build script

## 1.17.11 - 2023-10-17

- Allow adding environments to build in command parameters
- Allow rewriting Stapy tools CSS
- Editor CodeMirror updated to 5.65.15
- Editor textarea avoid horizontal resizing
- Editor new "inline style" option for fields
- Editor new "line break" option for fields

## 1.17.10 - 2023-09-01

- Custom HTTP headers
- Safe mode to hide error messages on a remote server
- Editor CodeMirror updated to version 5.65.14
- Full CodeMirror JS minified (-83ko)

## 1.17.9 - 2023-06-13

- Allow plugin in subdirectories
- Do not strip spaces in textarea
- Allow special chars in file path
- Editor media manager
- Editor code readability
- Editor CSS and JS outside the plugin script
- Editor warning message when changes are not saved
- Editor edit and remove pages logic updated

## 1.17.8 - 2023-05-25

- Ability to use the editor offline
- File type retrievement updated
- Allow to cancel parent template

## 1.17.7 - 2023-05-21

- Fix post data encoding

## 1.17.6 - 2023-05-04

- Use of email module instead of deprecated cgi to parse multipart data
- Fix editor reset button path on new page
- Editor CodeMirror updated to 5.65.13

## 1.17.5 - 2023-04-26

- Allow to post multipart/form-data
- Clean unknown vars in plugin and template tags
- New image and file types in editor
- Fix empty value in tag args when encode

## 1.17.4 - 2023-04-06

- Fix Pymdown extension dependency

## 1.17.3 - 2023-04-05

- Generate token for asset file based on update date
- Stapy toolkit added
- Do not convert markdown from the "assets" directory

## 1.17.2 - 2023-03-26

- Fix plugin always reloading after an update
- Unique token available when building
- Reload plugins before matching reserved requests

## 1.17.1 - 2023-03-13

- Allow to dispatch new plugin events in plugins
- Fix multiple message display in editor
- Scope of methods updated in editor plugin

## 1.17.0 - 2023-03-06

- Advanced JSON query
- Custom query data cache policy with a new plugin
- Pages data logic updated
- Implemented new plugin system logic
- Serve on 127.0.0.1 to avoid resolving localhost
- New plugin events: http_request_initialized and http_request_sent
- Blue background for a page not found

## 1.16.5 - 2023-02-13

- Fix double encoding in template tags
- Escape content tag included in template tags

## 1.16.4 - 2023-02-11

- Fix isolated quoted string in tags

## 1.16.3 - 2023-02-09

- New Stapy theme
- Current page data in child_content_data and child_content_query_result plugins
- Allow simple quote in tag arg values

## 1.16.2 - 2023-01-29

- Markdown plugin added
- Editor switcher
- Editor edit page actions restriction

## 1.16.1 - 2023-01-06

- Editor code char replacement improvements for HTML files

## 1.16.0 - 2023-01-01

- Page editor plugin added
- Share objects for performance improvements
- Exit although all created threads are not closed
- Serve from custom host
- Catch ConnectionResetError exception

## 1.15.4 - 2022-12-07

- Allow to send a custom HTTP response
- Json query and generator objects shared in all plugins
- Fix load of non script file in plugins directory
- Fix sort order with missing data
- Default template when missing, with the block "content"
- Fix full date with wrong format
- Fix minifier when css is not a physical file

## 1.15.3 - 2022-11-16

- Do not force line break after each block

## 1.15.2 - 2022-11-10

- Updated code style as recommended by Pylint
- Default JSON query limit updated

## 1.15.1 - 2022-11-09

- Woodpecker CI/CD pipeline added
- Specify the name of the plugin where to execute the method

## 1.15.0 - 2022-11-08

- Full rewrite of the parser to allow multi-line expressions

## 1.14.5 - 2022-11-03

- Allow adding arguments in a child block
- Escape curly brace in template

## 1.14.4 - 2022-10-30

- Post date format plugin added
- JSON query block separator option added

## 1.14.3 - 2022-10-27

- Better error messages
- Plug & Play plugin system

## 1.14.2 - 2022-10-25

- Allow to disable a page

## 1.14.1 - 2022-10-25

- Fix colons in arguments

## 1.14.0 - 2022-10-24

- Allow to build website offline with command line
- Auto-build system removed
- Useless cache system removed
- file_copy_before and file_copy_after events removed
- DELETE, PUT and POST HTTP methods removed
- Crawler removed
- Server script renamed to "stapy.py"

## 1.13.7 - 2022-10-19

- Plugin method arguments as optional

## 1.13.6 - 2022-10-17

- Child block parsing improvement

## 1.13.5 - 2022-10-07

- Allow to add custom arguments in a plugin method

## 1.13.4 - 2022-10-03

- Code style
- Avoid to remove .gitkeep file
- tmp extension added in temporary minified CSS file

## 1.13.3 - 2022-10-02

- Theme related post added
- Default theme improvements

## 1.13.2 - 2022-09-28

- JSON query cache removed

## 1.13.1 - 2022-09-27

- Fix minified file deletion in cssmin plugin
- Crawler performance improvement

## 1.13.0 - 2022-09-26

- New plugin tag in template
- Theme element page added
- Dedicated plugin class
- Force to reload plugin before generate a page

## 1.12.3 - 2022-09-20

- New default plugin for multi-pages

## 1.12.2 - 2022-09-16

- Do not serve configuration file without extension

## 1.12.1 - 2022-09-14

- JSON block name updated

## 1.12.0 - 2022-09-13

- Allow to use JSON value in block tags
- Built-in CSS minifier without dependency
- Always load directory files in alphabetical order

## 1.11.2 - 2022-09-10

- HTML tidy plugin added
- Default theme menu plugin added

## 1.11.1 - 2022-09-07

- Code style improvement
- Doctype added in error template

## 1.11.0 - 2022-09-06

- Welcome message added in console
- Error messages improvement

## 1.10.6 - 2022-09-05

- Better error messages

## 1.10.5 - 2022-06-28

- Allow to update child block template from plugin
- File System class added to plugins args
- Protected methods logic updated
- New event for update JSON single page data

## 1.10.4 - 2022-06-26

- New event for update JSON query page data
- Do not remove .gitignore when deleting files

## 1.10.3 - 2022-06-22

- Reserved _env variable added

## 1.10.2 - 2022-06-11

- Default site content updated

## 1.10.1 - 2022-06-08

- New cache system for performance improvement

## 1.10.0 - 2022-06-07

- Allow default configuration for subdirectories
- Default JSON configuration moved to layout directory

## 1.9.3 - 2022-06-05

- Replace tag by an empty string for None or False value

## 1.9.2 - 2022-05-31

- Fix wrong plugin script name

## 1.9.1 - 2022-05-26

- Type hints added (PEP 484)

## 1.9.0 - 2022-01-13

- Plugin system added

## 1.8.0 - 2022-01-04

- New default theme

## 1.7.2 - 2021-12-09

- Do not delete protected files during the crawl

## 1.7.1 - 2021-11-30

- Fix JSON query sort order with integer

## 1.7.0 - 2021-11-25

- Common JSON configuration for all file type (common.json)

## 1.6.2 - 2021-11-22

- JSON query tag

## 1.6.1 - 2021-11-17

- Allow to run local without the "web" directory

## 1.6.0 - 2021-11-15

- Resources directory renamed from "web" to "assets"
- Bash crawler replaced by an improved Python crawler
- Crawl speed improvement on Windows
- Unit test implementation
- Default JSON configuration according to file type
- Default page path variable added
- Use specific page data in block
- Reserved route added to retrieve all pages
- Reserved route added to retrieve page data
- Reserved route added to retrieve environments
- Default robots.txt added
- Default sitemap.xml added
- Force encoding to UTF-8
- Allow to serve any type of file
- HEAD request added to generate a page
- PUT request to copy all resources
- POST request to create files in specific environment
- DELETE request to remove built site

## 1.5.1 - 2021-06-01

- Ignore file writing broken pipe error

## 1.5.0 - 2021-05-04

- "build" directory renamed to "source"
- Default generic theme

## 1.4.2 - 2021-04-29

- Print error messages in console without all backtrace

## 1.4.1 - 2021-04-27

- Automatic file mime type assignation
- Default theme improvements

## 1.4.0 - 2021-04-26

- Multi-environments

## 1.3.0 - 2021-04-02

- Global page configuration in default.json
- Force JSON file encoding
- Normalize path for Windows
- Do not serve over SSL
- File system improvements
- Code refactoring
- Crawler timer added

## 1.2.2 - 2021-03-30

- Recursive parse in blocks
- Theme style minor improvements
- Multilanguage for default theme

## 1.2.1 - 2021-03-25

- Replace var with empty text for boolean value
- Default theme page 404 added

## 1.2.0 - 2021-03-24

- Block inclusion with curly-brace percent expression

## 1.1.3 - 2021-03-23

- Multiple thread to avoid resource latency

## 1.1.2 - 2021-03-23

- Page crawler added
- Build directory moved to root

## 1.1.1 - 2021-03-19

- Error messages improvement

## 1.1.0 - 2021-03-19

- HTTP response code refactoring
- Fix page path for index.html in subdirectories

## 1.0.0 - 2021-03-18

- First stable release